function K=kpls_makekernel(Xtr,Xts, kerneltype, kernelpar)

if isempty(Xts)
    
    switch kerneltype
        case 'linear'
            K=Xtr*Xtr'; 
        case 'gauss'
            K=fastdist(Xtr,Xtr);
            K=exp(-K./kernelpar);
        case 'hpol'
            K=Xtr*Xtr';
            K=K.^kernelpar;
        case 'ipol'
            K=Xtr*Xtr';
            K=K+ones(size(K));
            K=K.^kernelpar;
    end
    
else
    switch kerneltype
        case 'linear'
            K=Xts*Xtr'; 
        case 'gauss'
            K=fastdist(Xtr,Xts);
            K=exp(-K./kernelpar);
        case 'hpol'
            K=Xts*Xtr';
            K=K.^kernelpar;
        case 'ipol'
            K=Xts*Xtr';
            K=K+ones(size(K));
            K=K.^kernelpar;
    end
end


function D=fastdist(x,y)

% Calculated Euclideam distances between two sets of objetcs

D=(sum(y.^2,2)*ones(1,size(x,1)))+(ones(size(y,1),1)*(sum(x'.^2,1)))-2*(y*x');
    