function pred=kpls_pred(Xts, Yts, kmodel)

Xptr=applyprep(kmodel.Xdata, kmodel.preppars{1,1}, kmodel.preppars{1,2}, kmodel.preptype{1});
Xpts=applyprep(Xts, kmodel.preppars{1,1}, kmodel.preppars{1,2}, kmodel.preptype{1});
Ktr=kpls_makekernel(Xptr,[], kmodel.kerneltype, kmodel.kernelpar);
Kts=kpls_makekernel(Xptr,Xpts, kmodel.kerneltype, kmodel.kernelpar);
Kp=kpls_center(Ktr,Kts);
Yhat=Kp*kmodel.regcoef; 
Ypred=undoprep(Yhat, kmodel.preppars{2,1},kmodel.preppars{2,2},kmodel.preptype{2});

T=Kp*kmodel.Rweights;

pred.Xscores=T; 
pred.Ypred=Ypred; 
if ~isempty(Yts)
    rmsep=sqrt(sum((Ypred-Yts).^2)/size(Yts,1));
    bias=sum(Ypred-Yts)/size(Yts,1);
    vy=sum((Yts-repmat(mean(Yts), size(Yts,1),1)).^2);
    r2=1-(sum((Ypred-Yts).^2)./vy);
    pred.rmsep=rmsep; 
    pred.bias=bias; 
    pred.q2=r2;
else
    pred.rmsep=[]; 
    pred.bias=[]; 
    pred.q2=[];
end

pred.Xres=(Kp-T*kmodel.Xloads)*(eye(size(kmodel.Xscores,1))-kmodel.Xscores*kmodel.Xloads);















function Xp=applyprep(X,mx,sx,prettype)

switch prettype
    case 'none'
        Xp=X;
    case 'mean'
        Xp=X-repmat(mx, size(X,1),1);
    case 'auto'
        Xp=(X-repmat(mx, size(X,1),1))./repmat(sx, size(X,1),1);    
    case 'paretomc'
        Xp=(X-repmat(mx, size(X,1),1))./repmat(sx, size(X,1),1);    
    case 'uv'
        Xp=X./repmat(sx, size(X,1),1);
    case 'paretosc'
        Xp=X./repmat(sx, size(X,1),1);
    
end


function Xp=undoprep(X,mx,sx,prettype)

switch prettype
    case 'none'
        Xp=X;
    case 'mean'
        Xp=X+repmat(mx, size(X,1),1);
    case 'auto'
        Xp=(X.*repmat(sx, size(X,1),1))+repmat(mx, size(X,1),1);    
    case 'paretomc'
        Xp=(X.*repmat(sx, size(X,1),1))+repmat(mx, size(X,1),1);    
    case 'uv'
        Xp=X.*repmat(sx, size(X,1),1);
    case 'paretosc'
        Xp=X.*repmat(sx, size(X,1),1);
end