function model=reskdcv(ytrue, kmodel)

ypred=zeros(size(ytrue)); 
stdpred=ypred; 
confint=ypred; 

for i=1:length(ytrue)
a=find(kmodel.Ytrue==ytrue(i));
ypred(i)=mean(kmodel.Ypred(a));
stdpred(i)=std(kmodel.Ypred(a))/sqrt(length(a));
confint(i)=stdpred(i)*tinv(0.95, length(a)-1);
end

figure
plot(ytrue, ypred, 'or', 'markerfacecolor', 'r')
hold on

for i=1:length(ytrue)
plot([ytrue(i) ytrue(i)],[ypred(i)-confint(i) ypred(i)+confint(i)], 'k', 'linewidth', 1.2)
end

tss=sum((ytrue-mean(ytrue)).^2);
rss=sum((ypred-ytrue).^2);
q2=1-(rss/tss);
rmsep=sqrt(rss/length(ytrue)); 


model.Ypredave=ypred; 
model.Ypredstd=stdpred; 
model.Ypredconfint=confint; 
model.Ytrue=ytrue; 

model.q2=q2; 
model.rmsep=rmsep; 

makeline(ytrue, ypred);
axis tight


function makeline(ytrue, ypred)
m=min([min(ytrue) min(ypred)]);
M=max([max(ytrue) max(ypred)]);
r=M-m; 

b=pinv([ones(size(ytrue)) ytrue])*ypred; 
plot([m-0.1*r M+0.1*r]',[1 1;m-0.1*r M+0.1*r]'*b, '--b', 'linewidth', 1.2)
plot([m-0.1*r M+0.1*r]',[m-0.1*r M+0.1*r]', '-','color', [32 158 91]/255, 'linewidth', 1.2)

