%% Loads the data
load eedata

%% Builds the model and validates it on the test set
opt=kpls_cv('options');
opt.LVmax=15;
opt.kernelpar=[0.0001 0.0003162 0.0005 0.001 0.003162 0.005 0.01 0.03162 0.05 0.1];

m2=kpls_cv(Xmb(mm1,:), Yca(mm1,:), opt);
p2=kpls_pred(Xmb(tt1,:), Yca(tt1,:), m2.OptModel);
    
%% Plots the results
    eel={'RR', 'SS', 'RS', 'SR'}; 
    
    
    figure('units', 'normalized', 'position',[0.05 0.05 0.8 0.8])
    for i=1:4, 
        subplot(2,2,i),  
        plot(Yca(mm1,i), m2.OptModel.Ypred(:,i), 'or', 'markerfacecolor', 'r', 'markersize', 10), 
        hold on
        plot(Yca(tt1,i), p2.Ypred(:,i), 'sk', 'markerfacecolor' ,'k', 'markersize', 10), 
        plot([0 100], [0 100], '--b', 'linewidth', 1.5)
        axis tight
        set(gca, 'fontsize', 18, 'fontweight', 'bold', 'linewidth', 2)
        xlabel([eel{i}, '% measured'])
        ylabel([eel{i}, '% predicted'])
        title(eel{i}, 'fontsize', 20)
    end
        